#!/usr/bin/env node
var x = Object.defineProperty;
var S = (e, t, o) => t in e ? x(e, t, { enumerable: !0, configurable: !0, writable: !0, value: o }) : e[t] = o;
var h = (e, t, o) => (S(e, typeof t != "symbol" ? t + "" : t, o), o);
import { B as d, e as L } from "./api-client-1N4c98SW.js";
import { A as c, F as u } from "./app-automate-_tqyk8Kp.js";
import { randomBytes as P } from "node:crypto";
import { readFile as E } from "node:fs/promises";
import { createRequire as b } from "node:module";
import { resolve as T, basename as $ } from "node:path";
import F from "node:process";
function k(e) {
  const t = e ?? L.BROWSERSTACK_KEY;
  if (typeof t != "string" || !t.trim().length)
    throw new d("Missing key");
  return t.trim();
}
function R(e) {
  const t = e ?? L.BROWSERSTACK_USERNAME;
  if (typeof t != "string" || !t.trim().length)
    throw new d("Missing username");
  return t.trim();
}
const B = b(import.meta.url);
var v = /* @__PURE__ */ ((e) => (e.upload = "upload", e.get = "get", e.list = "list", e.delete = "delete", e))(v || {});
class w {
  constructor(t, o, n) {
    h(this, "platform");
    h(this, "supportedActions");
    h(this, "_implPlatformCommand");
    h(this, "_urlProtocol");
    this.platform = t, this.supportedActions = o, this._implPlatformCommand = n, this._urlProtocol = this._implPlatformCommand.getURLProtocol();
  }
  async list(t, o, n) {
    (await this._implPlatformCommand.list(t, o)).forEach((i) => this._logApp(i, n));
  }
  async upload(t, o, n) {
    const { filename: s, filePath: i, url: r, ...a } = t, l = await this._implPlatformCommand.upload(
      {
        filename: s,
        ...i ? { file: new Blob([await E(i)]) } : { url: r.toString() }
      },
      a,
      o
    ), p = l ? this._implPlatformCommand.getURL(l) : void 0;
    p ? n.info(p, "Uploaded successfully") : n.error("Failed to upload app", l);
  }
  async get(t, o, n) {
    const { id: s, ...i } = t, r = await this._implPlatformCommand.get(
      { id: this.cleanupId(s) },
      i,
      o
    );
    this._logApp(r, n);
  }
  async delete(t, o, n) {
    const { id: s, ...i } = t;
    await this._implPlatformCommand.delete(
      { id: this.cleanupId(s) },
      i,
      o
    ) ? n.info(`${this._urlProtocol}${s}`, "Deleted successfully") : n.error(`Failed to delete app: ${s}`);
  }
  _logApp(t, o) {
    o.info(...this._implPlatformCommand.logParams(t));
  }
  cleanupId(t, o = this._urlProtocol) {
    return t.startsWith(o) ? t.replace(o, "") : t;
  }
}
const C = (e) => {
  const { test_package_id: t, test_package_url: o, test_package_name: n, ...s } = e;
  return {
    ...s,
    app_id: t,
    app_url: o,
    app_name: n
  };
}, g = (e, t = Object.values(u)) => {
  if (!e || !t.includes(e))
    throw new d(
      `Invalid or missing flutter platform. Supported platforms: ${t.sort().join(", ")}`
    );
  return e;
}, _ = {
  getURLProtocol: () => "bs://",
  getURL: (e) => e == null ? void 0 : e.app_url,
  logParams: (e) => [
    (e == null ? void 0 : e.app_url) ?? "",
    e != null && e.uploaded_at ? new Date(e.uploaded_at).toISOString() : "",
    e == null ? void 0 : e.app_name,
    e == null ? void 0 : e.app_version
  ]
}, M = new w(
  "flutter",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    ..._,
    list: (e, t) => {
      var s, i, r, a;
      const o = new c(e);
      return g(
        (a = (r = (i = (s = t[0]) == null ? void 0 : s.toLowerCase) == null ? void 0 : i.call(s)) == null ? void 0 : r.trim) == null ? void 0 : a.call(r)
      ) === u.android ? o.getFlutterApps(u.android) : o.getFlutterApps(u.ios).then((l) => l.map(C));
    },
    upload: (e, t, o) => {
      var i, r, a, l, p, f, m, y;
      const n = new c(t);
      let s = (l = (a = (r = (i = o[0]) == null ? void 0 : i.toLowerCase) == null ? void 0 : r.call(i)) == null ? void 0 : a.trim) == null ? void 0 : l.call(a);
      return !s && ((y = (m = (f = (p = e.filename) == null ? void 0 : p.toLowerCase) == null ? void 0 : f.call(p)) == null ? void 0 : m.match) != null && y.call(m, /\.(apk|aar|appbundle)$/)) ? s = u.android : s = g(s), s === u.android ? n.uploadFlutterApp(u.android, e) : n.uploadFlutterApp(u.ios, e).then(C);
    },
    get: (e, t, o) => {
      var i, r, a, l;
      const n = new c(t);
      return g(
        (l = (a = (r = (i = o[0]) == null ? void 0 : i.toLowerCase) == null ? void 0 : r.call(i)) == null ? void 0 : a.trim) == null ? void 0 : l.call(a)
      ) === u.android ? n.getFlutterApp(u.android, e.id) : n.getFlutterApp(u.ios, e.id).then(C);
    },
    delete: async (e, t, o) => {
      var r, a, l, p, f, m;
      const n = new c(t), i = await (g(
        (p = (l = (a = (r = o[0]) == null ? void 0 : r.toLowerCase) == null ? void 0 : a.call(r)) == null ? void 0 : l.trim) == null ? void 0 : p.call(l)
      ) === u.android ? n.deleteFlutterApp(u.android, e.id) : n.deleteFlutterApp(u.ios, e.id));
      return ((m = (f = i == null ? void 0 : i.success) == null ? void 0 : f.message) == null ? void 0 : m.length) > 0;
    }
  }
), A = (e) => {
  if (!e.app_id || !e.custom_id)
    return e;
  const t = e.app_id;
  return {
    ...e,
    app_id: e.custom_id,
    app_url: e.app_url.replace(e.app_id, e.custom_id),
    custom_id: t
  };
}, O = new w(
  "appium",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    ..._,
    list: (e) => new c(e).getAppiumApps().then((o) => o.map(A)),
    upload: (e, t) => new c(t).uploadAppiumApp({
      ...e,
      custom_id: P(20).toString("hex")
    }).then(A),
    get: (e, t) => new c(t).getAppiumAppsByCustomId(e.id).then((n) => {
      if (!n.length)
        throw new d(`${e.id} Not found`);
      return A(n[0]);
    }),
    delete: async (e, t) => {
      const o = new c(t), [n] = await o.getAppiumAppsByCustomId(e.id), s = (n == null ? void 0 : n.app_id) ?? e.id, i = await o.deleteAppiumApp(s);
      return (i == null ? void 0 : i.success) === !0;
    }
  }
), N = new w(
  "espresso",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    ..._,
    list: (e) => new c(e).getEspressoApps(),
    upload: (e, t) => new c(t).uploadEspressoApp(e),
    get: (e, t) => new c(t).getEspressoApp(e.id),
    delete: async (e, t) => {
      var s, i;
      const n = await new c(t).deleteEspressoApp(e.id);
      return ((i = (s = n == null ? void 0 : n.success) == null ? void 0 : s.message) == null ? void 0 : i.length) > 0;
    }
  }
), W = new w(
  "xcuitest",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    ..._,
    list: (e) => new c(e).getXCUITestApps(),
    upload: (e, t) => new c(t).uploadXCUITestApp(e),
    get: (e, t) => new c(t).getXCUITestApp(e.id),
    delete: async (e, t) => {
      var s, i;
      const n = await new c(t).deleteXCUITestApp(e.id);
      return ((i = (s = n == null ? void 0 : n.success) == null ? void 0 : s.message) == null ? void 0 : i.length) > 0;
    }
  }
), D = new w(
  "detox",
  [
    "upload"
    /* upload */
  ],
  {
    ..._,
    upload: (e, t, o) => {
      var s, i, r, a;
      const n = (a = (r = (i = (s = o == null ? void 0 : o[0]) == null ? void 0 : s.toLowerCase) == null ? void 0 : i.call(s)) == null ? void 0 : r.trim) == null ? void 0 : a.call(r);
      switch (n) {
        case "app":
        case "app-client":
          return new c(t).uploadDetoxAndroidApp(n, e);
        default:
          throw new d(
            "Invalid or missing detox app type. Supported types: app, app-client"
          );
      }
    },
    list: () => {
      throw new d("Listing detox apps is not supported");
    },
    get: () => {
      throw new d("Fetching detox apps is not supported");
    },
    delete: () => {
      throw new d("Deleting detox apps is not supported");
    }
  }
), I = (e) => {
  if (!e.custom_id)
    return e;
  const t = e.media_id;
  return {
    ...e,
    media_id: e.custom_id,
    media_url: e.media_url.replace(e.media_id, e.custom_id),
    custom_id: t
  };
}, j = new w(
  "media",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    getURLProtocol: () => "media://",
    getURL: (e) => e == null ? void 0 : e.media_url,
    logParams: (e) => [
      (e == null ? void 0 : e.media_url) ?? "",
      e != null && e.uploaded_at ? new Date(e.uploaded_at).toISOString() : "",
      e == null ? void 0 : e.media_name
    ],
    list: (e) => new c(e).getMediaFiles().then((o) => o.map(I)),
    upload: (e, t) => {
      if (e.url)
        throw new d(
          "URL upload is not supported for media files"
        );
      if (!e.file)
        throw new d("No file provided for media upload");
      return new c(t).uploadMediaFile({
        ...e,
        custom_id: P(20).toString("hex")
      }).then(I);
    },
    get: (e, t) => new c(t).getMediaFilesByCustomId(e.id).then((n) => {
      if (!n.length)
        throw new d(`${e.id} Not found`);
      return I(n[0]);
    }),
    delete: async (e, t) => {
      const o = new c(t), [n] = await o.getMediaFilesByCustomId(e.id), s = (n == null ? void 0 : n.media_id) ?? e.id, i = await o.deleteMediaFile(s);
      return (i == null ? void 0 : i.success) === !0;
    }
  }
), U = new Map(
  [
    M,
    O,
    N,
    W,
    D,
    j
  ].map((e) => [e.platform, e])
);
async function K(e, t, o, n = globalThis.console, s = ["android", "ios"]) {
  var i, r, a;
  if (!e.supportedActions.includes(t))
    throw new d(
      `Invalid action: ${t} (valid actions: ${e.supportedActions.join(
        ", "
      )})`
    );
  switch (t) {
    case "upload": {
      const l = o.shift();
      if (!l)
        throw new d("No file path or URL provided");
      if ((a = (i = l == null ? void 0 : l.toLowerCase) == null ? void 0 : (r = i.call(l)).startsWith) != null && a.call(r, "http")) {
        if (!o[0] || s.includes(o[0]))
          throw new d("No filename provided for URL upload");
        return await e.upload(
          { url: new URL(l), filename: o[0] },
          o.slice(1),
          n
        );
      }
      const p = T(l);
      await e.upload(
        {
          filePath: p,
          filename: $(p)
        },
        o,
        n
      );
      break;
    }
    case "list": {
      await e.list({}, o, n);
      break;
    }
    case "get": {
      await e.get({ id: o[0] }, o.slice(1), n);
      break;
    }
    case "delete": {
      await e.delete({ id: o[0] }, o.slice(1), n);
      break;
    }
    default:
      throw new d(`Unsupported action: ${t}`);
  }
}
function X(e) {
  var o, n, s;
  const t = (s = (n = (o = e == null ? void 0 : e.toLowerCase) == null ? void 0 : o.call(e)) == null ? void 0 : n.trim) == null ? void 0 : s.call(n);
  if (t && U.has(t))
    return t;
  throw new d(`Invalid platform: ${t}`);
}
function q(e, t = Object.values(v)) {
  var n, s, i;
  const o = (i = (s = (n = e == null ? void 0 : e.toLowerCase) == null ? void 0 : n.call(e)) == null ? void 0 : s.trim) == null ? void 0 : i.call(s);
  if (o && t.includes(o))
    return o;
  throw new d(`Invalid action: ${o}`);
}
async function V(e = F.argv.slice(2), t = globalThis.console) {
  try {
    k(void 0), R(void 0);
    const o = e.map((i) => i.trim()), n = U.get(
      X(o[0])
    );
    if (!n)
      throw new d("Invalid platform");
    const s = q(o[1]);
    await K(n, s, o.slice(2), t);
  } catch (o) {
    o instanceof Error ? t.error(o.message) : t.error(`An unexpected error occurred: ${o}`), F.exit(1);
  }
}
B.main === module && V();
export {
  V as main
};
